<?php
namespace Teknisa\EST\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request\Filter;

class FilialFilioperController extends TeknisaCrud {
    
    protected $parameterBagColumns = ["CDOPERADOR", "NRORG"];
    protected $dataSourceName = 'filial_filioper';
    protected $dataSourceOriginal = 'filial_filioper';
    protected $dataSourcePerfilAcess = 'filial_filioper_perfilacess';
    protected $crudService;
	protected $dataSourceManager;
	protected $environment;
    protected $entityManager;

    public function __construct($crudService, ParameterBag $parameterBag, $dataSourceManager, $environment, $entityManager) {
		$this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
	}
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        $NRORG    = $this->environment->getNrOrgTrab();
        $utPerfilAcess = $this->environment->getIdUtlPerfilFilial();
        $codPerfilAcess = $this->environment->getNrPerfil();
        
        $filterCriteria = $request->getFilterCriteria();
        
        $conditions     = $filterCriteria->getConditions();
        
        $isNRORGset = $this->array_some($conditions, function($filter){
            return $filter['columnName'] == 'NRORG';
        });
        
        if(!$isNRORGset)
            $filterCriteria->addCondition('NRORG', $NRORG);
        
        if($utPerfilAcess == 'S'){
           $this->dataSourceName = $this->dataSourcePerfilAcess ;
           $filterCriteria->addCondition('PERFILACESSO', $codPerfilAcess);
           $this->parameterBagColumns = ["CDOPERADOR", "NRORG", "PERFILACESSO"];
        }else{
          $this->dataSourceName = $this->dataSourceOriginal;  
        } 
        $filterDebug = $filterCriteria->getConditions();
        //var_dump(get_class_methods($filterCriteria));die;
        parent::find($request, $response);
    }
    
    public function array_some(array $array, callable $fn) {
        foreach ($array as $value) {
            if($fn($value)) {
                return true;
            }
        }
        return false;
    }

}