function Est58100_RelatorioRetiradaEstoque_Controller (ScreenService, General, templateManager, ProductField, ZhFilterPreferences) {
    
    this.setNameLayout = function(args){
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
    
    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        let rowsToSet  = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = [success.dataset.filial[0].CDFILIAL];
            rowsToSet.NMFILIAL = [success.dataset.filial[0].NMFILIAL];
            ZhFilterPreferences.openFilterWidget(widget,rowsToSet).then(function(success) {
                templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("NMFILIAL").reload();
                this.verAlmoxarifado(templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions'));
            }.bind(this));
        }.bind(this));
    };
    
    
    this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
    
    this.disablePagination = function(args){
        args.owner.hasPagination = false;
    };
    
    this.reloadDataSoure = function(args){
        args.owner.reload();
        args.owner.hasPagination = false;
    };

    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
    
    this.verFilial = function(widget){
        var NMFILIAL = widget.getField('CDFILIAL').value();
        
    };
    
    this.verLocalEstVazio = function(widget){
        if (widget.getField('DSLOCALESTOQ').value() == ""){
            widget.getField('CDLOCALESTOQ').clearValue();
        }
    };
    
    // Habilita/Desabilita Almoxarifado
    this.verAlmoxarifado = function(widget){
        var NMFILIAL = widget.getField('NMFILIAL').value();
        if(NMFILIAL.length > 0){
            widget.getField('DSALMOXARIFE').readOnly = false;
            widget.getField('DSALMOXARIFE').dataSourceFilter.forEach(function(fil){
                if(fil.name == 'CDFILIAL') {    
                    fil.value = "";
                    if (Array.isArray(widget.getField('CDFILIAL').value())) {
                        fil.value = widget.getField('CDFILIAL').value().join("_");
                        fil.value = "_"+fil.value+"_";
                    }
                }
            });
        } else {
            widget.getField('DSALMOXARIFE').readOnly = true;
            widget.getField('DSALMOXARIFE').clearValue();
            widget.getField('CDALMOXARIFE').clearValue();
            widget.getField('DSLOCALESTOQ').readOnly = true;
            widget.getField('DSLOCALESTOQ').clearValue();
            widget.getField('CDLOCALESTOQ').clearValue();
        }
        if(NMFILIAL.length == 0){
            widget.getField('CDFILIAL').clearValue();
        } 
    };
    
    this.verLocalEst = function(widget){
        var NMFILIAL = widget.getField('CDFILIAL').value();
        var DSALMOXARIFE = widget.getField('DSALMOXARIFE').value();
        if((NMFILIAL.length) > 0 && (DSALMOXARIFE)){
            widget.getField('DSLOCALESTOQ').readOnly = false;
            widget.getField('DSLOCALESTOQ').dataSourceFilter.forEach(function(fil){
                if(fil.name == 'CDFILIAL') {    
                    fil.value = "";
                    if (Array.isArray(widget.getField('CDFILIAL').value())) {
                        fil.value = widget.getField('CDFILIAL').value().join("_");
                        fil.value = "_"+fil.value+"_";
                    }
                } else if(fil.name == 'CDALMOXARIFE') {
                    fil.value = widget.getField('CDALMOXARIFE').value();
                }
            });
        } else if(DSALMOXARIFE == ""){
            widget.getField('DSLOCALESTOQ').readOnly = true;
            widget.getField('DSLOCALESTOQ').clearValue();
            widget.getField('CDLOCALESTOQ').clearValue();
            widget.getField('DSALMOXARIFE').clearValue();
            widget.getField('CDALMOXARIFE').clearValue();
        } else if(NMFILIAL.length == 0){
            widget.getField('DSLOCALESTOQ').readOnly = true;
            widget.getField('DSLOCALESTOQ').clearValue();
            widget.getField('CDLOCALESTOQ').clearValue();
            widget.getField('DSALMOXARIFE').readOnly = true;
            widget.getField('DSALMOXARIFE').clearValue();
            widget.getField('CDALMOXARIFE').clearValue();
            widget.getField('NMFILIAL').clearValue();
        }
        if (widget.getField('DSALMOXARIFE').value() == ""){
            widget.getField('CDALMOXARIFE').clearValue();
        }
    };

    // Parâmetros Filtro
    this.preparaParametosQueryRequisicaoEstoque = function(widget, preference){
        var filterRow = preference.FILTER_ROW;
        
        var tamanhoMask = getLocalVar('CDPICTPROD').replace(/\./g,'').length;
        var tamanho = tamanhoMask - filterRow.CDPRODFIN.length;
        
        for(var i = 0; i < tamanho; i++){
        	filterRow.CDPRODFIN = filterRow.CDPRODFIN+"Z";
        }
        
        var filtroFilial = [];
        if(Array.isArray(filterRow.CDFILIAL) && filterRow.CDFILIAL.length > 0){
            filtroFilial= [
                {
                    "name":"CDFILIAL",
                    "operator":"=",
                    "value": "_"+filterRow.CDFILIAL.join("_")+"_"
                }
            ];
        }else{
            filtroFilial= [
                {
                    "name":"CDFILIAL",
                    "operator":"=",
                    "value": "T"
                }
            ];
        }
        
        var filtroTipoReti = [];
        if(Array.isArray(filterRow.CDTIPORETI) && filterRow.CDTIPORETI.length > 0){
            filtroTipoReti= [
                {
                    "name":"CDTIPORETI",
                    "operator":"=",
                    "value": "_"+filterRow.CDTIPORETI.join("_")+"_"
                }
            ];
        }else{
            filtroTipoReti= [
                {
                    "name":"CDTIPORETI",
                    "operator":"=",
                    "value": (filterRow.CDTIPORETI && filterRow.CDTIPORETI != 'T') ? "_"+filterRow.CDTIPORETI+"_" : 'T'
                }
            ];
        }
        
        var filtroCentiCust = [];
        if(Array.isArray(filterRow.CDCENTCUST) && filterRow.CDCENTCUST.length > 0){
            filtroCentiCust= [
                {
                    "name":"CDCENTCUST",
                    "operator":"=",
                    "value": "_"+filterRow.CDCENTCUST.join("_")+"_"
                }
            ];
        }else{
            filtroCentiCust= [
                {
                    "name":"CDCENTCUST",
                    "operator":"=",
                    "value": (filterRow.CDCENTCUST && filterRow.CDCENTCUST != 'T') ? "_"+filterRow.CDCENTCUST+"_" : 'T'
                }
            ];
        }

        var filtro= [
            {
                "name":"DTINICIAL",
                "operator":"=",
                "value": filterRow.DTRETIRADA ? filterRow.DTRETIRADA.start : null
            },
                            {
                "name":"DTFINAL",
                "operator":"=",
                "value": filterRow.DTRETIRADA ? filterRow.DTRETIRADA.end : null
            },
                            {
                "name":"CDPRODINI",
                "operator":"=",
                "value": filterRow.CDPRODINI ? filterRow.CDPRODINI : null
            },
                            {
                "name":"CDPRODFIN",
                "operator":"=",
                "value": filterRow.CDPRODFIN ? filterRow.CDPRODFIN : null
            },
                            {
                "name":"CDALMOXARIFE",
                "operator":"=",
                "value": filterRow.CDALMOXARIFE ? filterRow.CDALMOXARIFE : null
            },
            {
                "name":"CDLOCALESTOQ",
                "operator":"=",
                "value": filterRow.CDLOCALESTOQ ? filterRow.CDLOCALESTOQ : null
            }
        ];
        
        filtro.push(filtroFilial[0]);
        filtro.push(filtroTipoReti[0]);
        filtro.push(filtroCentiCust[0]);
        widget.dataSourceFilter = filtro;
        widget.reload();
        
    };
    
     this.prepareForDataExporter = function(widget) {
         /*
        var fieldAlmoxarife = widget.getField('DSALMOXARIFE');
        var fieldLocalEstoq = widget.getField('DSLOCALESTOQ');
        var fieldUnidade = widget.getField('NMFILIAL');
        var fieldCentCust = widget.getField('NMCENTCUST');
        if(fieldAlmoxarife.value() == "" || fieldAlmoxarife.value() == undefined)
            fieldAlmoxarife.dataSource.name = 'est_relatorios#/crud/almoxarifado';
        if(fieldLocalEstoq.value() == "" || fieldLocalEstoq.value() == undefined)
            fieldLocalEstoq.dataSource.name = 'est_relatorios#/crud/localestoque';
        if(fieldAlmoxarife.dataSource.data.length == 0){
            fieldAlmoxarife.dataSourceFilter = [];
            fieldAlmoxarife.reload();
            //fieldAlmoxarife.dataSource.load();
        }
        if(fieldLocalEstoq.dataSource.data.length == 0){
            fieldLocalEstoq.dataSourceFilter = [];
            fieldLocalEstoq.reload();
            //fieldLocalEstoq.dataSource.load();
        }
        if(fieldUnidade.dataSource.data.length == 0){
            fieldUnidade.dataSource.name = 'est#/crud/filial';
            fieldUnidade.dataSourceFilter = [];
            fieldUnidade.reload();
            //fieldUnidade.dataSource.load();
        }
        fieldCentCust.reload().then(()=> {
            fieldCentCust.dataSource.data.push({'NMCENTCUST': ' ', 'CDCENTCUST' : null}); 
        });
        */
        /* widget.fields.forEach(f => {
            if(f.dataSource)
                f.dataSource.load(); nao pode ser com foreach....
         });*/
     }; 
    
     this.changeHeaderValues = function(widget){
         this.prepareForDataExporter(widget.owner);
        /*var codigo; 
        var nmempresa = widget.owner.dataSource.data[0].NMEMPRESA;
        widget.owner.dataSourceFilter.forEach(function(empresa){
           if(empresa.name == 'CDEMPRESA'){
               codigo = empresa.value;
           } 
        });
        
        var cdempresa = {
            'label' : "Empresa",
            'value' : "is equal to".concat(codigo).concat(' - ').concat(nmempresa)
        };
        
        var filter = widget.e.metadata.filter;
        
        newFilter.push(cdempresa);
        filter.forEach(function(x){
            if(x.value != "is equal to."){
                newFilter.push(x);
            }
        });
        */
        /*
        var newFilter = [];
        var correctFilter = [];
        
        var value;
        newFilter.forEach(function(aux){
            if(aux.value.match(/is equal to/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }else if(aux.value.match(/is between/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }
        });
        
        widget.e.metadata.filter = correctFilter;    
    */
    };
    
    this.checkProductRange = function(field) {
        var currentRow = field.widget.currentRow;
      
        if(currentRow.CDPRODINI && currentRow.CDPRODFIN) {
            var compproduto = (currentRow.CDPRODFIN)? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

            if(!General.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
                currentRow[field.outData[field.descriptionField]] = null;
                currentRow[field.outData[field.valueField]] = null;

                ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
            }
        } 
    };
    
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Est58100_RelatorioRetiradaEstoque_Controller', Est58100_RelatorioRetiradaEstoque_Controller);
});
